# f[^e[u̍쐬
sub create_tables {
	local($cn, $ps, $rs, @dbdtables, @dbctables, @tablesname, @columnsname, @temptables, $query, $i, $j, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# TABLEXg
		@tablesname = ('AUTHOR', 'BOOKMARK', 'CATEGORY', 'COMMENT', 'EHIST', 'GUEST', 'HISTORY', 'IMAGE', 'LETTER', 'LINK', 'LINK_STOCK', 'MESSAGE', 'SESSIONID', 'SOUND', 'SSCOUNT', 'SSDATA', 'SSLIST', 'SSTYPE', 'STATUS', 'TAG', 'TWITTER', 'VALUE', 'MOVIE', 'SHARE');
		
		# e[u`
		@dbctables = ();
		# AUTHOR
		$i = 0;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_AUTHOR (
  AUTHOR_ID VARCHAR(020),
  AUTHOR_PASS VARCHAR(052),
  AUTHOR_NAME VARCHAR(100),
  AUTHOR_STATE TINYINT,
  AUTHOR_MAIL VARCHAR(256),
  AUTHOR_HOME VARCHAR(256),
  AUTHOR_COMMENT VARCHAR(1000),
  AUTHOR_BG INTEGER,
  AUTHOR_BGCOLOR VARCHAR(006),
  AUTHOR_TEXT VARCHAR(006),
  AUTHOR_ORDER INTEGER,
  AUTHOR_DATE DATETIME,
  AUTHOR_NOLETTER TINYINT,
  AUTHOR_NOMESSAGE TINYINT,
  CONSTRAINT PK_[#name#]_AUTHOR PRIMARY KEY (
    AUTHOR_ID
  )
)
EOM
		# BOOKMARK
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_BOOKMARK (
  AUTHOR_ID VARCHAR(020),
  BOOK_ID INTEGER,
  BOOK_IP VARCHAR(015),
  BOOK_TIME DATETIME,
  BOOK_NEW TINYINT,
  CONSTRAINT PK_[#name#]_BOOKMARK PRIMARY KEY (
    AUTHOR_ID,
    BOOK_ID,
    BOOK_IP
  )
)
EOM
		# CATEGORY
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_CATEGORY (
  AUTHOR_ID VARCHAR(020),
  CATE_ID INTEGER,
  CATE_NAME VARCHAR(200),
  CATE_DESCRIPTION VARCHAR(1000),
  CATE_ORDER INTEGER,
  CONSTRAINT PK_[#name#]_CATEGORY PRIMARY KEY (
    AUTHOR_ID,
    CATE_ID
  )
)
EOM
		# COMMENT
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_COMMENT (
  COMM_ID INTEGER,
  COMM_PAGE INTEGER,
  COMM_NO INTEGER,
  COMM_COMMENT VARCHAR(1000),
  CONSTRAINT PK_[#name#]_COMMENT PRIMARY KEY (
    COMM_ID,
    COMM_PAGE,
    COMM_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_COMMENT_IDX01 ON [#name#]_COMMENT (
  COMM_ID,
  COMM_PAGE
)
EOM
		# EHIST
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_EHIST (
  AUTHOR_ID VARCHAR(020),
  EHIST_NO INTEGER,
  EHIST_DATE DATETIME,
  CONSTRAINT PK_[#name#]_EHIST PRIMARY KEY (
    AUTHOR_ID,
    EHIST_NO
  )
)
EOM
		# GUEST
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_GUEST (
  GUEST_SSID INTEGER,
  GUEST_NAME VARCHAR(100),
  GUEST_PASS VARCHAR(052),
  GUEST_SESSION VARCHAR(052),
  GUEST_TIME DATETIME,
  CONSTRAINT PK_[#name#]_GUEST PRIMARY KEY (
    GUEST_SSID
  )
)
EOM
		# HISTORY
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_HISTORY (
  HIS_NO INTEGER,
  HIS_DATE DATETIME,
  HIS_ID VARCHAR(100),
  HIS_DESCRIPTION VARCHAR(100),
  HIS_SSID INTEGER,
  HIS_PAGE INTEGER,
  CONSTRAINT PK_[#name#]_HISTORY PRIMARY KEY (
    HIS_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_HISTORY_IDX01 ON [#name#]_HISTORY (
  HIS_ID
)
EOM
		# IMAGE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_IMAGE (
  IMAGE_ID INTEGER,
  IMAGE_NAME VARCHAR(200),
  IMAGE_TAIL VARCHAR(003),
  IMAGE_DESCRIPTION VARCHAR(1000),
  IMAGE_STATE TINYINT,
  IMAGE_UPPER VARCHAR(020),
  IMAGE_WIDTH INTEGER,
  IMAGE_HEIGHT INTEGER,
  IMAGE_FNAME VARCHAR(256),
  CONSTRAINT PK_[#name#]_IMAGE PRIMARY KEY (
    IMAGE_ID
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_IMAGE_IDX01 ON [#name#]_IMAGE (
  IMAGE_UPPER
)
EOM
		# LETTER
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_LETTER (
  LETTER_ID INTEGER,
  LETTER_AUTHOR VARCHAR(020),
  LETTER_NO INTEGER,
  LETTER_NAME VARCHAR(100),
  LETTER_TITLE VARCHAR(200),
  LETTER_TIME DATETIME,
  LETTER_MAIL VARCHAR(256),
  LETTER_HOME VARCHAR(256),
  LETTER_IP VARCHAR(015),
  LETTER_PASS VARCHAR(013),
  LETTER_DATA BLOB,
  CONSTRAINT PK_[#name#]_LETTER PRIMARY KEY (
    LETTER_ID,
	LETTER_AUTHOR,
    LETTER_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_LETTER_IDX01 ON [#name#]_LETTER (
  LETTER_ID
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_LETTER_IDX02 ON [#name#]_LETTER (
  LETTER_AUTHOR
)
EOM
		# LINK
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_LINK (
  LINK_ID INTEGER,
  LINK_ADDR VARCHAR(256),
  LINK_PATH VARCHAR(256),
  LINK_ENV_NO INTEGER,
  LINK_URL VARCHAR(256),
  LINK_NAME VARCHAR(200),
  LINK_DESC VARCHAR(1000),
  LINK_TIME DATETIME,
  LINK_EXEC TINYINT,
  LINK_ERR INTEGER,
  CONSTRAINT PK_[#name#]_LINK PRIMARY KEY (
    LINK_ID
  )
)
EOM
		# LINK_STOCK
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_LINK_STOCK (
  LINK_STOCK_ID INTEGER,
  LINK_STOCK_DATE DATETIME,
  LINK_STOCK_MESSAGE VARCHAR(200),
  LINK_STOCK_LINK INTEGER,
  CONSTRAINT PK_[#name#]_LINK_STOCK PRIMARY KEY (
    LINK_STOCK_ID,
    LINK_STOCK_DATE
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_LINK_STOCK_IDX01 ON [#name#]_LINK_STOCK (
  LINK_STOCK_LINK
)
EOM
		# MESSAGE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MESSAGE (
  AUTHOR_ID VARCHAR(020),
  MESSAGE_NO INTEGER,
  MESSAGE_ID VARCHAR(020),
  MESSAGE_TITLE VARCHAR(200),
  MESSAGE_TIME DATETIME,
  MESSAGE_FLG TINYINT,
  MESSAGE_DATA BLOB,
  MESSAGE_IP VARCHAR(015),
  CONSTRAINT PK_[#name#]_MESSAGE PRIMARY KEY (
    AUTHOR_ID,
    MESSAGE_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_MESSAGE_IDX01 ON [#name#]_MESSAGE (
  AUTHOR_ID
)
EOM
		# SESSIONID
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SESSIONID (
  SESSIONID_ID VARCHAR(052),
  SESSIONID_AUTHOR VARCHAR(020),
  SESSIONID_TIME DATETIME,
  SESSIONID_RESERVE TINYINT,
  SESSIONID_IP VARCHAR(015),
  SESSIONID_TYPE TINYINT,
  CONSTRAINT PK_[#name#]_SESSIONID PRIMARY KEY (
    SESSIONID_ID
  )
)
EOM
		# SOUND
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SOUND (
  SOUND_ID INTEGER,
  SOUND_NAME VARCHAR(200),
  SOUND_TAIL VARCHAR(003),
  SOUND_DESCRIPTION VARCHAR(1000),
  SOUND_STATE TINYINT,
  SOUND_UPPER VARCHAR(020),
  SOUND_FNAME VARCHAR(256),
  CONSTRAINT PK_[#name#]_SOUND PRIMARY KEY (
    SOUND_ID
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_SOUND_IDX01 ON [#name#]_SOUND (
  SOUND_UPPER
)
EOM
		# SSCOUNT
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SSCOUNT (
  SS_NO INTEGER,
  SS_SHOWED INTEGER,
  SS_LETTERS INTEGER,
  SS_COMMENTS INTEGER,
  CONSTRAINT PK_[#name#]_SSCOUNT PRIMARY KEY (
    SS_NO
  )
)
EOM
		# SSDATA
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SSDATA (
  SS_NO INTEGER,
  SS_PAGE INTEGER,
  SS_SOUND INTEGER,
  SS_IMAGE INTEGER,
  SS_BG INTEGER,
  SS_BGCOLOR VARCHAR(006),
  SS_TEXT VARCHAR(006),
  SS_BGFIX TINYINT,
  SS_TATE TINYINT,
  SS_FONT VARCHAR(020),
  SS_FONT_SIZE TINYINT,
  SS_FONT_HEIGHT DOUBLE,
  SS_DATA MEDIUMBLOB,
  CONSTRAINT PK_[#name#]_SSDATA PRIMARY KEY (
    SS_NO,
    SS_PAGE
  )
)
EOM
		# SSLIST
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SSLIST (
  SS_NO INTEGER,
  SS_AUTHOR VARCHAR(020),
  SS_TITLE VARCHAR(200),
  SS_DESCRIPTION VARCHAR(1000),
  SS_STATE TINYINT,
  SS_CATE INTEGER,
  SS_TYPE INTEGER,
  SS_TIMV TINYINT,
  SS_TAGLOCK TINYINT,
  SS_VALUATE TINYINT,
  SS_PAGE INTEGER,
  SS_ORDER INTEGER,
  SS_DATE DATETIME,
  SS_UPDATE DATETIME,
  SS_NOCOMMENT TINYINT,
  SS_NOLETTER TINYINT,
  CONSTRAINT PK_[#name#]_SSLIST PRIMARY KEY (
    SS_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_SSLIST_IDX01 ON [#name#]_SSLIST (
  SS_AUTHOR
)
EOM
		# SSTYPE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SSTYPE (
  SSTYPE_NO INTEGER,
  SSTYPE_NAME VARCHAR(200),
  SSTYPE_DESCRIPTION VARCHAR(1000),
  CONSTRAINT PK_[#name#]_SSTYPE PRIMARY KEY (
    SSTYPE_NO
  )
)
EOM
		# STATUS
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_STATUS (
  AUTHOR_ID VARCHAR(020),
  STATUS_SP TINYINT,
  STATUS_NO INTEGER,
  STATUS_SUBNO INTEGER
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_STATUS_IDX01 ON [#name#]_STATUS (
  AUTHOR_ID
)
EOM
		# TAG
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_TAG (
  TAG_ID INTEGER,
  TAG_PAGE INTEGER,
  TAG_NO INTEGER,
  TAG_TEXT VARCHAR(200),
  CONSTRAINT PK_[#name#]_TAG PRIMARY KEY (
    TAG_ID,
    TAG_PAGE,
    TAG_NO
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_TAG_IDX01 ON [#name#]_TAG (
  TAG_ID,
  TAG_PAGE
)
EOM
		# TWITTER
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_TWITTER (
  AUTHOR_ID VARCHAR(020),
  TWITTER_KEY VARCHAR(100),
  TWITTER_SEC VARCHAR(100),
  TWITTER_ACS VARCHAR(100),
  TWITTER_ACSSEC VARCHAR(100),
  CONSTRAINT PK_[#name#]_TWITTER PRIMARY KEY (
    AUTHOR_ID
  )
)
EOM
		# VALUE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_VALUE (
  VAL_SS INTEGER,
  VAL_POINT INTEGER,
  VAL_COUNT INTEGER,
  CONSTRAINT PK_[#name#]_VALUE PRIMARY KEY (
    VAL_SS,
    VAL_POINT
  )
)
EOM
		# VERSION
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE IF NOT EXISTS [#name#]_VERSION (
  VERSION_NO VARCHAR(020),
  VERSION_DATE DATETIME,
  VERSION_FLG TINYINT,
  CONSTRAINT PK_[#name#]_VERSION PRIMARY KEY (
    VERSION_NO
  )
)
EOM
		# MOVIE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MOVIE (
  MOVIE_ID INTEGER,
  MOVIE_NAME VARCHAR(200),
  MOVIE_TAIL VARCHAR(003),
  MOVIE_DESCRIPTION VARCHAR(1000),
  MOVIE_STATE TINYINT,
  MOVIE_UPPER VARCHAR(020),
  MOVIE_WIDTH INTEGER,
  MOVIE_HEIGHT INTEGER,
  MOVIE_FNAME VARCHAR(256),
  CONSTRAINT PK_[#name#]_MOVIE PRIMARY KEY (
    MOVIE_ID
  )
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_MOVIE_IDX01 ON [#name#]_MOVIE (
  MOVIE_UPPER
)
EOM
		# SHARE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_SHARE (
  SHARE_NO INTEGER,
  SHARE_ID VARCHAR(020)
)
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_SHARE_IDX01 ON [#name#]_SHARE (
  SHARE_NO
)
EOM
		
		# č쐬̏ꍇATEMPe[u̍폜ƍ쐬
		if ($_[1]) {
			@temptables = ();
			@columnsname = ();
			$query = 'SHOW TABLES';
			$ps = $cn->prepare($query);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@temptables, ${$rs}[0]);	}
			$ps->finish;
			for ($i = 0; $i <= $#tablesname; $i ++) {
				if (grep(/^$_[0]_$tablesname[$i]$/, @temptables)) {
					$j = 0;
					$query = "DESCRIBE $_[0]" . "_$tablesname[$i]";
					$ps = $cn->prepare($query);
					$ps->execute;
					while ($rs = $ps->fetch) {
						$columnsname[$i][$j] = ${$rs}[0];
						$j ++;
					}
					$ps->finish;
					$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]" . "_TEMP";
					$ps = $cn->prepare($query);
					$ps->execute;
					$ps->finish;
					$query = "ALTER TABLE $_[0]" . "_$tablesname[$i]" . " RENAME TO $_[0]" . "_$tablesname[$i]" . '_TEMP';
					$ps = $cn->prepare($query);
					$ps->execute;
					$ps->finish;
				} else {	@{$columnsname[$i]} = ();	}
			}
		# ʏ쐬̏ꍇA݃e[u̍폜
		} else {
			# DROP
			for ($i = 0; $i <= $#tablesname; $i ++) {
				$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]";
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
			}
		}
		
		# CREATE
		for ($i = 0; $i <= $#dbctables; $i ++) {
			$query = $dbctables[$i];
			if ($_[2]) {	$query .= " TYPE = MyISAM";	}
			else {	$query = " TYPE = InnoDB";	}
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute;
			$ps->finish;
		}
		
		# č쐬̏ꍇATEMPe[üڍsTEMPe[u̍폜
		if ($_[1]) {
			for ($i = 0; $i <= $#tablesname; $i ++) {
				if ($#{$columnsname[$i]} < 0) {	next;	}
				$query = "INSERT INTO $_[0]" . "_$tablesname[$i] (";
				for ($j = 0; $j <= $#{$columnsname[$i]}; $j ++) {
					if ($j == 0) {	$query .= $columnsname[$i][$j];	}
					else {	$query .= ", $columnsname[$i][$j]";	}
				}
				$query .= ') SELECT ';
				for ($j = 0; $j <= $#{$columnsname[$i]}; $j ++) {
					if ($j == 0) {	$query .= $columnsname[$i][$j];	}
					else {	$query .= ", $columnsname[$i][$j]";	}
				}
				$query .= " FROM $_[0]" . "_$tablesname[$i]" . '_TEMP';
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
				$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]" . '_TEMP';
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
			}
			$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 1 WHERE VERSION_NO = ?';
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			if ($ps->execute($dbversion) <= 0) {
				$ps->finish;
				$query = 'INSERT INTO [#name#]_VERSION (VERSION_NO, VERSION_DATE, VERSION_FLG) VALUES (?, SYSDATE(), 1)';
				$query =~ s/\[#name#\]/$_[0]/g;
				$ps = $cn->prepare($query);
				$ps->execute($dbversion);
			}
			$ps->finish;
			$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 0 WHERE VERSION_NO != ?';
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute($dbversion);
			$ps->finish;
		# ʏ쐬̏ꍇAT[o[f[^̈ڍs
		} else {	$errflg = &update_tables($_[0]);	}
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# f[^x[X̃NA
sub truncate_tables {
	local($cn, $ps, $query, @dbttables, $i, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# TRUNCATEXg
		@dbttables = ('TRUNCATE TABLE [#name#]_AUTHOR', 'TRUNCATE TABLE [#name#]_BOOKMARK', 'TRUNCATE TABLE [#name#]_CATEGORY', 'TRUNCATE TABLE [#name#]_COMMENT', 'TRUNCATE TABLE [#name#]_EHIST', 'TRUNCATE TABLE [#name#]_GUEST', 'TRUNCATE TABLE [#name#]_HISTORY', 'TRUNCATE TABLE [#name#]_IMAGE', 'TRUNCATE TABLE [#name#]_LETTER', 'TRUNCATE TABLE [#name#]_LINK', 'TRUNCATE TABLE [#name#]_LINK_STOCK', 'TRUNCATE TABLE [#name#]_MESSAGE', 'TRUNCATE TABLE [#name#]_SESSIONID', 'TRUNCATE TABLE [#name#]_SOUND', 'TRUNCATE TABLE [#name#]_SSCOUNT', 'TRUNCATE TABLE [#name#]_SSDATA', 'TRUNCATE TABLE [#name#]_SSLIST', 'TRUNCATE TABLE [#name#]_SSTYPE', 'TRUNCATE TABLE [#name#]_STATUS', 'TRUNCATE TABLE [#name#]_TAG', 'TRUNCATE TABLE [#name#]_TWITTER', 'TRUNCATE TABLE [#name#]_VALUE', 'TRUNCATE TABLE [#name#]_MOVIE');
		# TRUNCATE
		for ($i = 0; $i <= $#dbttables; $i ++) {
			$query = $dbttables[$i];
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute;
			$ps->finish;
		}
		
		$errflg = &update_tables($_[0]);
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# [Jf[^̃Abvf[g
sub update_tables {
	local($cn, $ps, $query, $flist, $yyyy, $mm, $dd, $hh, $mi, $sec, @date_str, $i, $j, $k, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		#AUTHOR
		$query = <<EOM;
INSERT INTO [#name#]_AUTHOR (
  AUTHOR_ID,
  AUTHOR_PASS,
  AUTHOR_NAME,
  AUTHOR_STATE,
  AUTHOR_MAIL,
  AUTHOR_HOME,
  AUTHOR_COMMENT,
  AUTHOR_BG,
  AUTHOR_BGCOLOR,
  AUTHOR_TEXT,
  AUTHOR_ORDER,
  AUTHOR_DATE,
  AUTHOR_NOLETTER,
  AUTHOR_NOMESSAGE
) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ADDTIME(SYSDATE(), ?), ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&author_decode;
		&author_flow_decode;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_flow_id; $j ++) {
			if (exists($AUTHOR_POINT{$author_flow_id[$j]}))
			{
				$i = $AUTHOR_POINT{$author_flow_id[$j]};
				$author_bgcolor[$i] =~ s/#//g;
				$author_text[$i] =~ s/#//g;
				$ps->execute($author_id[$i], $author_pass[$i], $author_name[$i], $author_state[$i], $author_mail[$i], $author_home[$i], $author_comment[$i], $author_bg[$i], $author_bgcolor[$i], $author_text[$i], $j + 1, int($i / 86400) . ' ' . int($i % 86400 / 3600) . ':' . int($i % 3600 / 60) . ':' . ($i % 60), $author_noletter[$i], $author_nomessage[$i]);
			}
		}
		for ($i = 0; $i <= $#author_id; $i ++) {
			if (!grep(/^$author_id[$i]$/, @author_flow_id)) {
				push(@author_flow_id, $author_id[$i]);
				$ps->execute($author_id[$i], $author_pass[$i], $author_name[$i], $author_state[$i], $author_mail[$i], $author_home[$i], $author_comment[$i], $author_bg[$i], $author_bgcolor[$i], $author_text[$i], $#author_flow_id + 1, $i, $author_noletter[$i], $author_nomessage[$i]);
			}
		}
		$ps->finish;
		# BOOKMARK
		$query = <<EOM;
INSERT INTO [#name#]_BOOKMARK (
  AUTHOR_ID,
  BOOK_ID,
  BOOK_IP,
  BOOK_TIME,
  BOOK_NEW
) VALUES (?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_id; $j ++) {
			if (&bookmark_decode("$ss/bookmark-$author_id[$j].dat") eq 'true') {
				for ($i = 0; $i <= $#book_id; $i ++) {
					($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($book_time[$i]);
					$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
					$ps->execute($author_id[$j], $book_id[$i], $book_ip[$i], $date_str[0], $book_new[$i]);
				}
			}
		}
		$ps->finish;
		# CATEGORY
		$query = <<EOM;
INSERT INTO [#name#]_CATEGORY (
  AUTHOR_ID,
  CATE_ID,
  CATE_NAME,
  CATE_DESCRIPTION,
  CATE_ORDER
) VALUES (?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_id; $j ++) {
			if (&category_decode("$ss/$author_id[$j].dat") eq 'true') {
				for ($i = 0; $i <= $#cate_id; $i ++) {	$ps->execute($author_id[$j], $cate_id[$i], $cate_name[$i], $cate_description[$i], $i + 1);	}
			}
		}
		$ps->finish;
		# SSLIST
		$query = <<EOM;
INSERT INTO [#name#]_SSLIST (
  SS_NO,
  SS_AUTHOR,
  SS_TITLE,
  SS_DESCRIPTION,
  SS_STATE,
  SS_CATE,
  SS_TYPE,
  SS_TIMV,
  SS_TAGLOCK,
  SS_VALUATE,
  SS_PAGE,
  SS_ORDER,
  SS_DATE,
  SS_UPDATE,
  SS_NOCOMMENT,
  SS_NOLETTER
) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s', ?, ?))
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sslist_decode;
		&ss_flow_decode;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_flow_no; $j ++) {
			if (exists($SS_POINT{$ss_flow_no[$j]})) {
				$i = $SS_POINT{$ss_flow_no[$j]};
				($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($ss_date[$i]);
				$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
				($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($ss_update[$i]);
				$date_str[1] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
				$ps->execute($ss_no[$i], $ss_author[$i], $ss_title[$i], $ss_description[$i], $ss_state[$i], $ss_cate[$i], $ss_type[$i], $ss_timv[$i], $ss_taglock[$i], $ss_valuate[$i], $ss_page2[$i], $j + 1, $date_str[0], $date_str[1], $ss_nocomment[$i], $ss_noletter[$i]);
			}
		}
		for ($i = 0; $i <= $#ss_no; $i ++) {
			if (!grep(/^$ss_no[$i]$/, @ss_flow_no)) {
				push(@ss_flow_no, $ss_no[$i]);
				($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($ss_date[$i]);
				$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
				($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($ss_update[$i]);
				$date_str[1] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
				$ps->execute($ss_no[$i], $ss_author[$i], $ss_title[$i], $ss_description[$i], $ss_state[$i], $ss_cate[$i], $ss_type[$i], $ss_timv[$i], $ss_taglock[$i], $ss_valuate[$i], $ss_page2[$i], $#ss_flow_no, $date_str[0], $date_str[1], $ss_nocomment[$i], $ss_noletter[$i]);
			}
		}
		$ps->finish;
		# COMMENT
		$query = <<EOM;
INSERT INTO [#name#]_COMMENT (
  COMM_ID,
  COMM_PAGE,
  COMM_NO,
  COMM_COMMENT
) VALUES (?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			for ($k = 1; $k <= $ss_page2[$j]; $k ++) {
				if (&comment_decode("$letter/$ss_no[$j]-$k-comment.dat") eq 'true') {
					for ($i = 0; $i <= $#comm_comment; $i ++) {	$ps->execute($ss_no[$j], $k, $i + 1, $comm_comment[$i]);	}
				}
			}
		}
		$ps->finish;
		# EHIST
		$query = <<EOM;
INSERT INTO [#name#]_EHIST (
  AUTHOR_ID,
  EHIST_NO,
  EHIST_DATE
) VALUES (?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'))
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_id; $j ++) {
			if (&ehist_decode("$ss/ehist-$author_id[$j].dat") eq 'true') {
				for ($i = 0; $i <= $#ehist_no; $i ++) {
					($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($ehist_date[$i]);
					$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
					$ps->execute($author_id[$j], $ehist_no[$i], $date_str[0]);
				}
			}
		}
		$ps->finish;
		# GUEST
		$query = <<EOM;
INSERT INTO [#name#]_GUEST (
  GUEST_SSID,
  GUEST_NAME,
  GUEST_PASS,
  GUEST_SESSION,
  GUEST_TIME
) VALUES (?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'))
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&guest_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#guest_ssid; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($guest_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($guest_ssid[$i], $guest_name[$i], $guest_pass[$i], $guest_session[$i], $date_str[0]);
		}
		$ps->finish;
		# HISTORY
		$query = <<EOM;
INSERT INTO [#name#]_HISTORY (
  HIS_NO,
  HIS_DATE,
  HIS_ID,
  HIS_DESCRIPTION,
  HIS_SSID,
  HIS_PAGE
) VALUES (?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&history_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#his_no; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($his_date[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($his_no[$i], $date_str[0], $his_id[$i], $his_description[$i], $his_ssid[$i], $his_page[$i]);
		}
		$ps->finish;
		# IMAGE
		$query = <<EOM;
INSERT INTO [#name#]_IMAGE (
  IMAGE_ID,
  IMAGE_NAME,
  IMAGE_TAIL,
  IMAGE_DESCRIPTION,
  IMAGE_STATE,
  IMAGE_UPPER,
  IMAGE_WIDTH,
  IMAGE_HEIGHT,
  IMAGE_FNAME
) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&image_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#image_id; $i ++) {	$ps->execute($image_id[$i], $image_name[$i], $image_tail[$i], $image_description[$i], $image_state[$i], $image_upper[$i], $image_width[$i], $image_height[$i], $image_fname[$i]);	}
		$ps->finish;
		# LETTER
		$query = <<EOM;
INSERT INTO [#name#]_LETTER (
  LETTER_ID,
  LETTER_AUTHOR,
  LETTER_NO,
  LETTER_NAME,
  LETTER_TITLE,
  LETTER_TIME,
  LETTER_MAIL,
  LETTER_HOME,
  LETTER_IP,
  LETTER_PASS,
  LETTER_DATA
) VALUES (?, ?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			if (&letter_decode("$letter/$ss_no[$j]-letter.dat") eq 'true') {
				for ($i = 0; $i <= $#letter_no; $i ++) {
					$flist = '';
					for ($k = 0; $k < $letter_length[$i]; $k ++) {	$flist .= "$letter_data[$i][$k]\n";	}
					$flist .= $letter_data[$i][$letter_length[$i]];
					($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($letter_time[$i]);
					$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
					$ps->execute($ss_no[$j], 'DUMMY_USER', $letter_no[$i], $letter_name[$i], $letter_title[$i], $date_str[0], $letter_mail[$i], $letter_home[$i], $letter_ip[$i], $letter_pass[$i], $flist);
				}
			}
		}
		for ($j = 0; $j <= $#author_id; $j ++) {
			if (&letter_decode("$letter/$author_id[$j]-letter.dat") eq 'true') {
				for ($i = 0; $i <= $#letter_no; $i ++) {
					$flist = '';
					for ($k = 0; $k < $letter_length[$i]; $k ++) {	$flist .= "$letter_data[$i][$k]\n";	}
					$flist .= $letter_data[$i][$letter_length[$i]];
					($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($letter_time[$i]);
					$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
					$ps->execute(0, $author_id[$j], $letter_no[$i], $letter_name[$i], $letter_title[$i], $date_str[0], $letter_mail[$i], $letter_home[$i], $letter_ip[$i], $letter_pass[$i], $flist);
				}
			}
		}
		$ps->finish;
		# LINK
		$query = <<EOM;
INSERT INTO [#name#]_LINK (
  LINK_ID,
  LINK_ADDR,
  LINK_PATH,
  LINK_ENV_NO,
  LINK_URL,
  LINK_NAME,
  LINK_DESC,
  LINK_TIME,
  LINK_EXEC,
  LINK_ERR
) VALUES (?, ?, ?, ?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&link_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#link_id; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($link_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($link_id[$i], $link_addr[$i], $link_path[$i], $link_env_no[$i], $link_url[$i], $link_name[$i], $link_desc[$i], $date_str[0], $link_exec[$i], $link_err[$i]);
		}
		$ps->finish;
		# LINK_STOCK
		$query = <<EOM;
INSERT INTO [#name#]_LINK_STOCK (
  LINK_STOCK_ID,
  LINK_STOCK_DATE,
  LINK_STOCK_MESSAGE,
  LINK_STOCK_LINK
) VALUES (?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&link_stock_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#link_stock_date; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($link_stock_date[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$date_str[1] = $link_stock_id[$i];
			if ($date_str[1] eq 'self') {	$date_str[1] = 0;	}
			$ps->execute($link_stock_id[$i], $date_str[0], $link_stock_message[$i], $link_stock_link[$i]);
		}
		$ps->finish;
		# MESSAGE
		$query = <<EOM;
INSERT INTO [#name#]_MESSAGE (
  AUTHOR_ID,
  MESSAGE_NO,
  MESSAGE_ID,
  MESSAGE_TITLE,
  MESSAGE_TIME,
  MESSAGE_FLG,
  MESSAGE_DATA,
  MESSAGE_IP
) VALUES (?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_id; $j ++) {
			if (&message_decode("$letter/message-$author_id[$j].dat") eq 'true') {
				for ($i = 0; $i <= $#message_no; $i ++) {
					$flist = '';
					for ($k = 0; $k < $message_length[$i]; $k ++) {	$flist .= "$message_data[$i][$k]\n";	}
					$flist .= $message_data[$i][$message_length[$i]];
					($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($message_time[$i]);
					$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
					$ps->execute($author_id[$j], $message_no[$i], $message_id[$i], $message_title[$i], $date_str[0], $message_flg[$i], $flist, $message_ip[$i]);
				}
			}
		}
		$ps->finish;
		# SESSIONID
		$query = <<EOM;
INSERT INTO [#name#]_SESSIONID (
  SESSIONID_ID,
  SESSIONID_AUTHOR,
  SESSIONID_TIME,
  SESSIONID_RESERVE,
  SESSIONID_IP,
  SESSIONID_TYPE
) VALUES (?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sessionid_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#sessionid_id; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($sessionid_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($sessionid_id[$i], $sessionid_author[$i], $date_str[0], $sessionid_reserve[$i], $sessionid_ip[$i], $sessionid_type[$i]);
		}
		$ps->finish;
		# SOUND
		$query = <<EOM;
INSERT INTO [#name#]_SOUND (
  SOUND_ID,
  SOUND_NAME,
  SOUND_TAIL,
  SOUND_DESCRIPTION,
  SOUND_STATE,
  SOUND_UPPER,
  SOUND_FNAME
) VALUES (?, ?, ?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sound_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#sound_id; $i ++) {	$ps->execute($sound_id[$i], $sound_name[$i], $sound_tail[$i], $sound_description[$i], $sound_state[$i], $sound_upper[$i], $sound_fname[$i]);	}
		$ps->finish;
		# SSCOUNT
		$query = <<EOM;
INSERT INTO [#name#]_SSCOUNT (
  SS_NO,
  SS_SHOWED,
  SS_LETTERS,
  SS_COMMENTS
) VALUES (?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sscountlist_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#ss_no; $i ++) {
			if (exists($SSCID{$ss_no[$i]})) {
				$j = $SSCID{$ss_no[$i]};
				$date_str[0] = $ss_showed[$i] + $ss_countshowed[$j];
				$date_str[1] = $ss_letters[$i] + $ss_countletters[$j];
				$date_str[2] = $ss_comments[$i] + $ss_countcomments[$j];
			} else {
				$date_str[0] = $ss_showed[$i];
				$date_str[1] = $ss_letters[$i];
				$date_str[2] = $ss_comments[$i];
			}
			$ps->execute($ss_no[$i], $date_str[0], $date_str[1], $date_str[2]);
		}
		$ps->finish;
		# SSDATA
		$query = <<EOM;
INSERT INTO [#name#]_SSDATA (
  SS_NO,
  SS_PAGE,
  SS_SOUND,
  SS_IMAGE,
  SS_BG,
  SS_BGCOLOR,
  SS_TEXT,
  SS_BGFIX,
  SS_TATE,
  SS_FONT,
  SS_FONT_SIZE,
  SS_FONT_HEIGHT,
  SS_DATA
) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			if (&ss_decode("$ss/$ss_no[$j].dat") eq 'true') {
				for ($i = 1; $i <= $ss_page; $i ++) {
					$flist = '';
					for ($k = 0; $k < $ss_length[$i]; $k ++) {	$flist .= "$ss_data[$i][$k]\n";	}
					$flist .= $ss_data[$i][$ss_length[$i]];
					if ($ss_sound[$i] eq 'nodata') {	$ss_sound[$i] = 0;	}
					if ($ss_image[$i] eq 'nodata') {	$ss_image[$i] = 0;	}
					if ($ss_bg[$i] eq 'nodata') {	$ss_bg[$i] = 0;	}
					$ss_bgcolor[$i] =~ s/#//g;
					$ss_text[$i] =~ s/#//g;
					$ps->execute($ss_no[$j], $i, $ss_sound[$i], $ss_image[$i], $ss_bg[0], $ss_bgcolor[$i], $ss_text[$i], $ss_bgfix[$i], $ss_tate[$i], $ss_font[$i], $ss_font_size[$i], $ss_font_height[$i], $flist);
					if (!$ss_sound[$i]) {	$ss_sound[$i] = 'nodata';	}
					if (!$ss_image[$i]) {	$ss_image[$i] = 'nodata';	}
					if (!$ss_bg[$i]) {	$ss_bg[$i] = 'nodata';	}
				}
			}
		}
		$ps->finish;
		# SSTYPE
		$query = <<EOM;
INSERT INTO [#name#]_SSTYPE (
  SSTYPE_NO,
  SSTYPE_NAME,
  SSTYPE_DESCRIPTION
) VALUES (?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sstype_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#sstype_no; $i ++) {	$ps->execute($sstype_no[$i], $sstype_name[$i], $sstype_descript[$i]);	}
		$ps->finish;
		# STATUS
		$query = <<EOM;
INSERT INTO [#name#]_STATUS (
  AUTHOR_ID,
  STATUS_SP,
  STATUS_NO,
  STATUS_SUBNO
) VALUES (?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#author_id; $j ++) {
			&status_decode("$ss/status-$author_id[$j].dat");
			for ($i = 0; $i <= $#status_letter; $i ++) {	$ps->execute($author_id[$j], 0, $status_letter[$i], 0);	}
			for ($i = 0; $i <= $#status_comment; $i ++) {	$ps->execute($author_id[$j], 1, $status_comment[$i], 0);	}
			$ps->execute($author_id[$j], 2, $status_message, 0);
			for ($i = 0; $i <= $#status_value; $i ++) {	$ps->execute($author_id[$j], 3, split(/-/, $status_value[$i]));	}
			$ps->execute($author_id[$j], 4, $status_newauthor, 0);
			$ps->execute($author_id[$j], 5, $status_newss, 0);
			$ps->execute($author_id[$j], 6, $status_newbook, 0);
			for ($i = 0; $i <= $#status_tag; $i ++) {	$ps->execute($author_id[$j], 7, $status_tag, 0);	}
		}
		$ps->finish;
		# TAG
		$query = <<EOM;
INSERT INTO [#name#]_TAG (
  TAG_ID,
  TAG_PAGE,
  TAG_NO,
  TAG_TEXT
) VALUES (?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			for ($i = 1; $i <= $ss_page2[$j]; $i ++) {
				if (&tag_decode("$letter/$ss_no[$j]-$i-tags.dat") eq 'true') {
					for ($k = 0; $k <= $#tag_text; $k ++) {	$ps->execute($ss_no[$j], $i, $k + 1, $tag_text[$k]);	}
				}
			}
		}
		$ps->finish;
		# TWITTER
		$query = <<EOM;
INSERT INTO [#name#]_TWITTER (
  AUTHOR_ID,
  TWITTER_KEY,
  TWITTER_SEC,
  TWITTER_ACS,
  TWITTER_ACSSEC
) VALUES (?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			@date_str = @{&file_read(OUT, "$ss/twitter-$author_id[$i].dat", 0)};
			chomp(@date_str);
			if (!$filerr) {	$ps->execute($author_id[$i], $date_str[0], $date_str[1], $date_str[2], $date_str[3]);	}
		}
		$ps->finish;
		# VALUE
		$query = <<EOM;
INSERT INTO [#name#]_VALUE (
  VAL_SS,
  VAL_POINT,
  VAL_COUNT
) VALUES (?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&value_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#val_ss; $i ++) {
			if (exists($SS_POINT{$val_ss[$i]})) {
				$ps->execute($val_ss[$i], 1, $val_one[$i]);
				$ps->execute($val_ss[$i], 2, $val_two[$i]);
				$ps->execute($val_ss[$i], 3, $val_three[$i]);
				$ps->execute($val_ss[$i], 4, $val_four[$i]);
				$ps->execute($val_ss[$i], 5, $val_five[$i]);
			}
		}
		$ps->finish;
		# VERSION
		$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 1 WHERE VERSION_NO = ?';
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		if ($ps->execute($dbversion) <= 0) {
			$ps->finish;
			$query = 'INSERT INTO [#name#]_VERSION (VERSION_NO, VERSION_DATE, VERSION_FLG) VALUES (?, SYSDATE(), 1)';
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute($dbversion);
		}
		$ps->finish;
		$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 0 WHERE VERSION_NO != ?';
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		$ps->execute($dbversion);
		$ps->finish;
		# MOVIE
		$query = <<EOM;
INSERT INTO [#name#]_MOVIE (
  MOVIE_ID,
  MOVIE_NAME,
  MOVIE_TAIL,
  MOVIE_DESCRIPTION,
  MOVIE_STATE,
  MOVIE_UPPER,
  MOVIE_WIDTH,
  MOVIE_HEIGHT,
  MOVIE_FNAME
) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&movie_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#movie_id; $i ++) {	$ps->execute($movie_id[$i], $movie_name[$i], $movie_tail[$i], $movie_description[$i], $movie_state[$i], $movie_upper[$i], $movie_width[$i], $movie_height[$i], $movie_fname[$i]);	}
		$ps->finish;
		# SHARE
		$query = <<EOM;
INSERT INTO [#name#]_SHARE (
  SHARE_NO,
  SHARE_ID
) VALUES (?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&share_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#share_no; $i ++) {	$ps->execute($share_no[$i], $share_id[$i]);	}
		$ps->finish;
		
		$cn->do('COMMIT');
	};
	if ($@) {
		$errflg = $@;
		$cn->do('ROLLBACK');
	}
	
	return $errflg;
}


# [Jf[^ɃobNAbv
sub backup_tables {
	local($cn, $ps, $rs, $query, @tempstr, $flist, $yyyy, $mm, $dd, $hh, $mi, $sec, $flow_list_ref, @flow_list, $i, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		#AUTHOR
		$query = <<EOM;
SELECT
  AUTHOR_ID,
  AUTHOR_PASS,
  AUTHOR_NAME,
  AUTHOR_STATE,
  AUTHOR_MAIL,
  AUTHOR_HOME,
  AUTHOR_COMMENT,
  AUTHOR_BG,
  AUTHOR_BGCOLOR,
  AUTHOR_TEXT,
  AUTHOR_ORDER,
  AUTHOR_NOLETTER,
  AUTHOR_NOMESSAGE
FROM [#name#]_AUTHOR
ORDER BY AUTHOR_DATE
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&author_initialize;
		@flow_list = ();
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@author_id, ${$rs}[0]);
			push(@author_pass, ${$rs}[1]);
			push(@author_name, ${$rs}[2]);
			push(@author_state, ${$rs}[3]);
			push(@author_mail, ${$rs}[4]);
			push(@author_home, ${$rs}[5]);
			push(@author_comment, ${$rs}[6]);
			push(@author_bg, ${$rs}[7]);
			push(@author_bgcolor, ${$rs}[8]);
			push(@author_text, ${$rs}[9]);
			push(@flow_list, ${$rs}[10]);
			push(@author_noletter, ${$rs}[11]);
			push(@author_nomessage, ${$rs}[12]);
		}
		$ps->finish;
		$author_open = 1;
		&author_save;
		@author_flow_id = ();
		$flow_list_ref = &array_sort(0, \@flow_list);
		for ($i = 0; $i <= $#{$flow_list_ref}; $i ++) {	push(@author_flow_id, $author_id[${$flow_list_ref}[$i]]);	}
		$author_flow_open = 1;
		&author_flow_save;
		# BOOKMARK
		$query = <<EOM;
SELECT
  BOOK_ID,
  BOOK_IP,
  DATE_FORMAT(BOOK_TIME, '%Y/%m/%d/%H/%i/%s'),
  BOOK_NEW
FROM [#name#]_BOOKMARK
WHERE AUTHOR_ID = ?
ORDER BY BOOK_TIME
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			&bookmark_initialize;
			$ps->bind_param(1, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@book_id, ${$rs}[0]);
				push(@book_ip, ${$rs}[1]);
				push(@book_time, &get_timevalue(split(/\//, ${$rs}[2])));
				push(@book_new, ${$rs}[2]);
			}
			&bookmark_save("$ss/bookmark-$author_id[$i].dat");
		}
		$ps->finish;
		# CATEGORY
		$query = <<EOM;
SELECT
  CATE_ID,
  CATE_NAME,
  CATE_DESCRIPTION
FROM [#name#]_CATEGORY
WHERE AUTHOR_ID = ?
ORDER BY CATE_ORDER
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			&category_initialize;
			$ps->bind_param(1, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@cate_id, ${$rs}[0]);
				push(@cate_name, ${$rs}[1]);
				push(@cate_description, ${$rs}[2]);
			}
			$category_open = 1;
			&category_save("$ss/$author_id[$i].dat");
		}
		$ps->finish;
		# EHIST
		$query = <<EOM;
SELECT
  EHIST_NO,
  DATE_FORMAT(EHIST_DATE, '%Y/%m/%d/%H/%i/%s')
FROM [#name#]_EHIST
WHERE AUTHOR_ID = ?
ORDER BY EHIST_DATE DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			@ehist_no = ();
			@ehist_date = ();
			$ps->bind_param(1, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {
				push(@ehist_no, ${$rs}[0]);
				push(@ehist_date, &get_timevalue(split(/\//, ${$rs}[1])));
			}
			&ehist_save("$ss/ehist-$author_id[$i].dat");
		}
		$ps->finish;
		# SSLIST
		$query = <<EOM;
SELECT
  SS_NO,
  SS_AUTHOR,
  SS_TITLE,
  SS_DESCRIPTION,
  SS_STATE,
  SS_CATE,
  SS_TYPE,
  SS_TIMV,
  SS_TAGLOCK,
  SS_VALUATE,
  SS_PAGE,
  DATE_FORMAT(SS_DATE, '%Y/%m/%d/%H/%i/%s'),
  DATE_FORMAT(SS_UPDATE, '%Y/%m/%d/%H/%i/%s'),
  SS_ORDER,
  SS_NOCOMMENT,
  SS_NOLETTER
FROM [#name#]_SSLIST
ORDER BY SS_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sslist_initialize;
		@flow_list = ();
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@ss_no, ${$rs}[0]);
			push(@ss_author, ${$rs}[1]);
			push(@ss_title, ${$rs}[2]);
			push(@ss_description, ${$rs}[3]);
			push(@ss_state, ${$rs}[4]);
			push(@ss_cate, ${$rs}[5]);
			push(@ss_type, ${$rs}[6]);
			push(@ss_timv, ${$rs}[7]);
			push(@ss_taglock, ${$rs}[8]);
			push(@ss_valuate, ${$rs}[9]);
			push(@ss_page2, ${$rs}[10]);
			push(@ss_date, &get_timevalue(split(/\//, ${$rs}[11])));
			push(@ss_update, &get_timevalue(split(/\//, ${$rs}[12])));
			push(@flow_list, ${$rs}[13]);
			push(@ss_nocomment, ${$rs}[14]);
			push(@ss_letter, ${$rs}[15]);
		}
		$ps->finish;
		$sslist_open = 1;
		&sslist_save;
		@ss_flow_no = ();
		$flow_list_ref = &array_sort(0, \@flow_list);
		for ($i = 0; $i <= $#{$flow_list_ref}; $i ++) {	push(@ss_flow_no, $ss_no[${$flow_list_ref}[$i]]);	}
		$ss_flow_open = 1;
		&ss_flow_save;
		# COMMENT
		$query = <<EOM;
SELECT
  COMM_COMMENT
FROM [#name#]_COMMENT
WHERE COMM_ID = ?
  AND COMM_PAGE = ?
ORDER BY COMM_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			for ($k = 1; $k <= $ss_page2[$j]; $k ++) {
				$flist = '';
				$ps->bind_param(1, $ss_no[$j]);
				$ps->bind_param(2, $k);
				$ps->execute;
				while ($rs = $ps->fetch) {	$flist .= "${$rs}[0]\n";	}
				&file_write(OUT, "$letter/$ss_no[$j]-$k-comment.dat", \$flist, 0, 0);
			}
		}
		$ps->finish;
		# GUEST
		$query = <<EOM;
SELECT
  GUEST_SSID,
  GUEST_NAME,
  GUEST_PASS,
  GUEST_SESSION,
  DATE_FORMAT(GUEST_TIME, '%Y/%m/%d/%H/%i/%s')
FROM [#name#]_GUEST
ORDER BY GUEST_SSID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&guest_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@guest_ssid, ${$rs}[0]);
			push(@guest_name, ${$rs}[1]);
			push(@guest_pass, ${$rs}[2]);
			push(@guest_session, ${$rs}[3]);
			push(@guest_time, &get_timevalue(split(/\//, ${$rs}[4])));
		}
		$ps->finish;
		$guest_open = 1;
		&guest_save;
		# HISTORY
		$query = <<EOM;
SELECT
  HIS_NO,
  DATE_FORMAT(HIS_DATE, '%Y/%m/%d/%H/%i/%s'),
  HIS_ID,
  HIS_DESCRIPTION,
  HIS_SSID,
  HIS_PAGE
FROM [#name#]_HISTORY
ORDER BY HIS_NO DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&history_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@his_no, ${$rs}[0]);
			push(@his_date, &get_timevalue(split(/\//, ${$rs}[1])));
			push(@his_id, ${$rs}[2]);
			push(@his_description, ${$rs}[3]);
			push(@his_ssid, ${$rs}[4]);
			push(@his_page, ${$rs}[5]);
		}
		$ps->finish;
		$history_open = 1;
		&history_save;
		# IMAGE
		$query = <<EOM;
SELECT
  IMAGE_ID,
  IMAGE_NAME,
  IMAGE_TAIL,
  IMAGE_DESCRIPTION,
  IMAGE_STATE,
  IMAGE_UPPER,
  IMAGE_WIDTH,
  IMAGE_HEIGHT,
  IMAGE_FNAME
FROM [#name#]_IMAGE
ORDER BY IMAGE_ID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&image_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@image_id, ${$rs}[0]);
			push(@image_name, ${$rs}[1]);
			push(@image_tail, ${$rs}[2]);
			push(@image_description, ${$rs}[3]);
			push(@image_state, ${$rs}[4]);
			push(@image_upper, ${$rs}[5]);
			push(@image_width, ${$rs}[6]);
			push(@image_height, ${$rs}[7]);
			push(@image_fname, ${$rs}[8]);
		}
		$ps->finish;
		$image_open = 1;
		&image_save;
		# LETTER
		$query = <<EOM;
SELECT
  LETTER_NO,
  LETTER_NAME,
  LETTER_TITLE,
  DATE_FORMAT(LETTER_TIME, '%Y/%m/%d/%H/%i/%s'),
  LETTER_MAIL,
  LETTER_HOME,
  LETTER_IP,
  LETTER_PASS,
  LETTER_DATA
FROM [#name#]_LETTER
WHERE LETTER_ID = ?
  AND LETTER_AUTHOR = ?
ORDER BY LETTER_ID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#ss_no; $i ++) {
			$flist = '';
			$ps->bind_param(1, $ss_no[$i]);
			$ps->bind_param(2, 'DUMMY_USER');
			$ps->execute;
			while ($rs = $ps->fetch) {
				$tempstr[0] = ${$rs}[1];
				$tempstr[1] = ${$rs}[2];
				$tempstr[2] = ${$rs}[4];
				$tempstr[3] = ${$rs}[5];
				$tempstr[0] =~ s/,/&comma;/g;
				$tempstr[1] =~ s/,/&comma;/g;
				$tempstr[2] =~ s/,/&comma;/g;
				$tempstr[3] =~ s/,/&comma;/g;
				$flist .= "${$rs}[0],$tempstr[0],${$rs}[7],$tempstr[1]," . &get_timevalue(split(/\//, ${$rs}[3])) . ",$tempstr[2],$tempstr[3],${$rs}[6]\n${$rs}[8]\n<>\n";
			}
			&file_write(OUT, "$letter/$ss_no[$i]-letter.dat", \$flist, 0, 0);
		}
		for ($i = 0; $i <= $#author_id; $i ++) {
			$flist = '';
			$ps->bind_param(1, 0);
			$ps->bind_param(2, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {	$flist .= "${$rs}[0],${$rs}[1],${$rs}[7],${$rs}[2]," . &get_timevalue(split(/\//, ${$rs}[3])) . ",${$rs}[4],${$rs}[5],${$rs}[6]\n${$rs}[8]\n<>\n";	}
			&file_write(OUT, "$letter/$author_id[$i]-letter.dat", \$flist, 0, 0);
		}
		$ps->finish;
		# LINK
		$query = <<EOM;
SELECT
  LINK_ID,
  LINK_ADDR,
  LINK_PATH,
  LINK_ENV_NO,
  LINK_URL,
  LINK_NAME,
  LINK_DESC,
  DATE_FORMAT(LINK_TIME, '%Y/%m/%d/%H/%i/%s'),
  LINK_EXEC,
  LINK_ERR
FROM [#name#]_LINK
ORDER BY LINK_ID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&link_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@link_id, ${$rs}[0]);
			push(@link_addr, ${$rs}[1]);
			push(@link_path, ${$rs}[2]);
			push(@link_env_no, ${$rs}[3]);
			push(@link_url, ${$rs}[4]);
			push(@link_name, ${$rs}[5]);
			push(@link_desc, ${$rs}[6]);
			push(@link_time, &get_timevalue(split(/\//, ${$rs}[7])));
			push(@link_exec, ${$rs}[8]);
			push(@link_err, ${$rs}[9]);
		}
		$ps->finish;
		$link_open = 1;
		&link_save;
		# LINK_STOCK
		$query = <<EOM;
SELECT
  LINK_STOCK_ID,
  DATE_FORMAT(LINK_STOCK_DATE, '%Y/%m/%d/%H/%i/%s'),
  LINK_STOCK_MESSAGE,
  LINK_STOCK_LINK
FROM [#name#]_LINK_STOCK
ORDER BY LINK_STOCK_DATE DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&link_stock_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@link_stock_id, ${$rs}[0]);
			if (!$link_stock_id[$#link_stock_id]) {	$link_stock_id[$#link_stock_id] = 'self';	}
			push(@link_stock_date, &get_timevalue(split(/\//, ${$rs}[1])));
			push(@link_stock_message, ${$rs}[2]);
			push(@link_stock_link, ${$rs}[3]);
		}
		$ps->finish;
		$link_stock_open = 1;
		&link_stock_save;
		# MESSAGE
		$query = <<EOM;
SELECT
  MESSAGE_NO,
  MESSAGE_ID,
  MESSAGE_TITLE,
  DATE_FORMAT(MESSAGE_TIME, '%Y/%m/%d/%H/%i/%s'),
  MESSAGE_FLG,
  MESSAGE_DATA,
  MESSAGE_IP
FROM [#name#]_MESSAGE
WHERE AUTHOR_ID = ?
ORDER BY MESSAGE_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			$flist = '';
			$ps->bind_param(1, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {
				$tempstr[0] = ${$rs}[2];
				$tempstr[0] =~ s/,/&comma;/g;
				$flist .= "${$rs}[0],${$rs}[1],$tempstr[0]," . &get_timevalue(split(/\//, ${$rs}[3])) . ",${$rs}[4],${$rs}[6]\n${$rs}[5]\n<>\n";
			}
			&file_write(OUT, "$letter/message-$author_id[$i].dat", \$flist, 0, 0);
		}
		$ps->finish;
		# SESSIONID
		$query = <<EOM;
SELECT
  SESSIONID_ID,
  SESSIONID_AUTHOR,
  DATE_FORMAT(SESSIONID_TIME, '%Y/%m/%d/%H/%i/%s'),
  SESSIONID_RESERVE,
  SESSIONID_IP,
  SESSIONID_TYPE
FROM [#name#]_SESSIONID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sessionid_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@sessionid_id, ${$rs}[0]);
			push(@sessionid_author, ${$rs}[1]);
			push(@sessionid_time, &get_timevalue(split(/\//, ${$rs}[2])));
			push(@sessionid_reserve, ${$rs}[3]);
			push(@sessionid_ip, ${$rs}[4]);
			push(@sessionid_type, ${$rs}[5]);
		}
		$ps->finish;
		$sessionid_open = 1;
		&sessionid_save;
		# SOUND
		$query = <<EOM;
SELECT
  SOUND_ID,
  SOUND_NAME,
  SOUND_TAIL,
  SOUND_DESCRIPTION,
  SOUND_STATE,
  SOUND_UPPER,
  SOUND_FNAME
FROM [#name#]_SOUND
ORDER BY SOUND_ID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sound_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@sound_id, ${$rs}[0]);
			push(@sound_name, ${$rs}[1]);
			push(@sound_tail, ${$rs}[2]);
			push(@sound_description, ${$rs}[3]);
			push(@sound_state, ${$rs}[4]);
			push(@sound_upper, ${$rs}[5]);
			push(@sound_fname, ${$rs}[6]);
		}
		$ps->finish;
		$sound_open = 1;
		&sound_save;
		# SSCOUNT
		$query = <<EOM;
SELECT
  SS_NO,
  SS_SHOWED,
  SS_LETTERS,
  SS_COMMENTS
FROM [#name#]_SSCOUNT
ORDER BY SS_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sscountlist_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@ss_countno, ${$rs}[0]);
			push(@ss_countshowed, ${$rs}[1]);
			push(@ss_countletters, ${$rs}[2]);
			push(@ss_countcomments, ${$rs}[3]);
		}
		$ps->finish;
		$sscountlist_open = 1;
		&sscountlist_save;
		# SSDATA
		$query = <<EOM;
SELECT
  SS_SOUND,
  SS_IMAGE,
  SS_BG,
  SS_BGCOLOR,
  SS_TEXT,
  SS_BGFIX,
  SS_TATE,
  SS_FONT,
  SS_FONT_SIZE,
  SS_FONT_HEIGHT,
  SS_DATA
FROM [#name#]_SSDATA
WHERE SS_NO = ?
ORDER BY SS_PAGE
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#ss_no; $i ++) {
			$flist = '';
			$ps->bind_param(1, $ss_no[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {
				$tempstr[0] = ${$rs}[3];
				$tempstr[1] = ${$rs}[4];
				$tempstr[2] = ${$rs}[7];
				$tempstr[3] = ${$rs}[0];
				if (!$tempstr[3]) {	$tempstr[3] = 'nodata';	}
				$tempstr[4] = ${$rs}[1];
				if (!$tempstr[4]) {	$tempstr[4] = 'nodata';	}
				$tempstr[5] = ${$rs}[2];
				if (!$tempstr[5]) {	$tempstr[5] = 'nodata';	}
				$tempstr[0] =~ s/,/&comma;/g;
				$tempstr[1] =~ s/,/&comma;/g;
				$tempstr[2] =~ s/,/&comma;/g;
				$flist .= "$tempstr[3],$tempstr[4],$tempstr[5],$tempstr[0],$tempstr[1],${$rs}[5],${$rs}[6],$tempstr[2],${$rs}[8],${$rs}[9]\n${$rs}[10]\n<>\n";
			}
			&file_write(OUT, "$ss/$ss_no[$i].dat", \$flist, 0, 0);
		}
		$ps->finish;
		# SSTYPE
		$query = <<EOM;
SELECT
  SSTYPE_NO,
  SSTYPE_NAME,
  SSTYPE_DESCRIPTION
FROM [#name#]_SSTYPE
ORDER BY SSTYPE_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&sstype_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@sstype_no, ${$rs}[0]);
			push(@sstype_name, ${$rs}[1]);
			push(@sstype_descript, ${$rs}[2]);
		}
		$ps->finish;
		$sstype_open = 1;
		&sstype_save;
		# STATUS
		$query = <<EOM;
SELECT
  STATUS_NO,
  STATUS_SUBNO
FROM [#name#]_STATUS
WHERE AUTHOR_ID = ?
  AND STATUS_SP = ?
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			&status_initialize;
			$ps->bind_param(1, $author_id[$i]);
			$ps->bind_param(2, 0);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@status_letter, ${$rs}[0]);	}
			$ps->bind_param(2, 1);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@status_comment, ${$rs}[0]);	}
			$ps->bind_param(2, 2);
			$ps->execute;
			if ($rs = $ps->fetch && ${$rs}[0]) {	$status_message = 1;	}
			$ps->bind_param(2, 3);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@status_value, "${$rs}[0]-${$rs}[1]");	}
			$ps->bind_param(2, 4);
			$ps->execute;
			if ($rs = $ps->fetch && ${$rs}[0]) {	$status_newauthor = 1;	}
			$ps->bind_param(2, 5);
			$ps->execute;
			if ($rs = $ps->fetch && ${$rs}[0]) {	$status_newss = 1;	}
			$ps->bind_param(2, 6);
			$ps->execute;
			if ($rs = $ps->fetch && ${$rs}[0]) {	$status_newbook = 1;	}
			&status_save("$ss/status-$author_id[$i].dat");
		}
		$ps->finish;
		# TAG
		$query = <<EOM;
SELECT
  TAG_TEXT
FROM [#name#]_TAG
WHERE TAG_ID = ?
  AND TAG_PAGE = ?
ORDER BY TAG_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($j = 0; $j <= $#ss_no; $j ++) {
			for ($k = 1; $k <= $ss_page2[$j]; $k ++) {
				$flist = '';
				$ps->bind_param(1, $ss_no[$j]);
				$ps->bind_param(2, $k);
				$ps->execute;
				while ($rs = $ps->fetch) {	$flist .= "${$rs}[0] ";	}
				$flist =~ s/ $//g;
				&file_write(OUT, "$letter/$ss_no[$j]-$k-tags.dat", \$flist, 0, 0);
			}
		}
		$ps->finish;
		# TWITTER
		$query = <<EOM;
SELECT
  TWITTER_KEY,
  TWITTER_SEC,
  TWITTER_ACS,
  TWITTER_ACSSEC
FROM [#name#]_TWITTER
WHERE AUTHOR_ID = ?
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#author_id; $i ++) {
			$ps->bind_param(1, $author_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {	&file_write(OUT, "$ss/twitter-$author_id[$i].dat", \"${$rs}[0]\n${$rs}[1]\n${$rs}[2]\n${$rs}[3]\n", 0, 0);	}
		}
		$ps->finish;
		# VALUE
		$query = <<EOM;
SELECT
  VAL_SS,
  VAL_POINT,
  VAL_COUNT
FROM [#name#]_VALUE
ORDER BY VAL_SS, VAL_POINT
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&value_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			if ($#val_ss < 0 || $val_ss[$#val_ss] != ${$rs}[0]) {	push(@val_ss, ${$rs}[0]);	}
			if (${$rs}[1] == 1) {	push(@val_one, ${$rs}[2]);	}
			elsif (${$rs}[1] == 2) {	push(@val_two, ${$rs}[2]);	}
			elsif (${$rs}[1] == 3) {	push(@val_three, ${$rs}[2]);	}
			elsif (${$rs}[1] == 4) {	push(@val_four, ${$rs}[2]);	}
			elsif (${$rs}[1] == 5) {	push(@val_five, ${$rs}[2]);	}
		}
		$ps->finish;
		$value_open = 1;
		&value_save;
		# MOVIE
		$query = <<EOM;
SELECT
  MOVIE_ID,
  MOVIE_NAME,
  MOVIE_TAIL,
  MOVIE_DESCRIPTION,
  MOVIE_STATE,
  MOVIE_UPPER,
  MOVIE_WIDTH,
  MOVIE_HEIGHT,
  MOVIE_FNAME
FROM [#name#]_MOVIE
ORDER BY MOVIE_ID
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&movie_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@movie_id, ${$rs}[0]);
			push(@movie_name, ${$rs}[1]);
			push(@movie_tail, ${$rs}[2]);
			push(@movie_description, ${$rs}[3]);
			push(@movie_state, ${$rs}[4]);
			push(@movie_upper, ${$rs}[5]);
			push(@movie_width, ${$rs}[6]);
			push(@movie_height, ${$rs}[7]);
			push(@movie_fname, ${$rs}[8]);
		}
		$ps->finish;
		$movie_open = 1;
		&movie_save;
		# MOVIE
		$query = <<EOM;
SELECT
  SHARE_NO,
  SHARE_ID
FROM [#name#]_MOVIE
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&share_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@share_no, ${$rs}[0]);
			push(@share_id, ${$rs}[1]);
		}
		$ps->finish;
		$share_open = 1;
		&share_save;
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# e[uftO
sub deflagment_tables {
	local($cn, @tablesname, $query, $i, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# TABLEXg
		@tablesname = ('AUTHOR', 'BOOKMARK', 'CATEGORY', 'COMMENT', 'EHIST', 'GUEST', 'HISTORY', 'IMAGE', 'LETTER', 'LINK', 'LINK_STOCK', 'MESSAGE', 'SESSIONID', 'SOUND', 'SSCOUNT', 'SSDATA', 'SSLIST', 'SSTYPE', 'STATUS', 'TAG', 'TWITTER', 'VALUE', 'VERSION', 'MOVIE', 'SHARE');
		for ($i = 0; $i <= $#tablesname; $i ++) {
			$query = "ALTER TABLE [#name#]_$tablesname[$i]";
			if ($_[1]) {	$query .= " TYPE = MyISAM";	}
			else {	$query .= " TYPE = InnoDB";	}
			$query =~ s/\[#name#\]/$_[0]/g;
			$cn->do($query);
		}
		$cn->do('COMMIT');
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# ҏW̃fR[h
sub ehist_decode {
	local($elist_ref, $i);
	
	$elist_ref = &file_read(OUT, $_[0], 0);
	if ($filerr) {	return 'false';	}
	
	@ehist_no = ();
	@ehist_date = ();
	
	chomp(@{$elist_ref});
	for ($i = 0; $i <= $#{$elist_ref}; $i ++) {	($ehist_no[$i], $ehist_date[$i]) = split(/,/, ${$elist_ref}[$i]);	}
	
	return 'true';
}


# ҏW̕ۑ
sub ehist_save {
	local(@list, $i, $flist);
	
	@list = ();
	$flist = '';
	for ($i = 0; $i <= $#ehist_no; $i ++) {
		if (!grep(/^$ehist_no[$i]$/, @list)) {
			$flist .= "$ehist_no[$i],$ehist_date[$i]\n";
			push(@list, $ehist_no[$i]);
			if ($#list >= $e_max_history - 1) {	last;	}
		}
	}
	
	if (-e "$ss/ehist-$id.dat") {
		if (&file_write(OUT, $_[0], \$flist, 2, 0)) {	return 'true';	}
		else {	return 'false';	}
	} else {
		if (&file_write(OUT, $_[0], \$flist, 0, 0)) {	return 'true';	}
		else {	return 'false';	}
	}
}


1;

__END__

